'Datei fr Attiny-Platine von E. Eube, G. Heinrichs und U. Ihlefeldt
'Attiny2313 als I2C-Slave -> Ansteuerung ber COMX bzw. I2CTest2.exe
'Slave gibt Ton aus. Der Ton dauert 1 s lang; die Frequenz hngt vom bertragenen Wert ab.
'
'Achtung Achtung Achtung:
'Wenn die Attiny-Platine an die I2C-Interface-Platine angeschlossen wird, muss
'die Attiny-Platine ausgeschaltet bleiben, weil sie dann ber die Interface-Platine versorgt wird.
'Auerdem mssen in diesem Fall die I2C-Jumper auf der Attiny-Platine entfernt werden;
'denn die Pull-Up-Widerstnde befinden sich auch bereits auf der I2C-Interface-Platine.
'
'B5 -> SDA
'B7 -> SCL
'INT1 = PortD.3 an SDA = PortB.5 anschlieen fr Interrupt, kontrolliert stopp-Signal
'LED an PortD.6 zeigt an, ob Slave aktiv ist oder nicht
'
'Anzeige mit LC-Display
'Copyright Hr 30.10.10
'Version 1.2
'Achtung: LCD braucht Zeit fr die Darstellung der empfangenen Bits (min. ca. 1 - 2 ms)
'Stopp-Signal implementiert
'--------------------------------------------------------------------------------


$regfile = "attiny2313.dat"                                 'Attiny2313
$crystal = 4000000                                          '4 MHz


'**********************************************************
'******************* Deklarationen ************************

Declare Function Empfangebyte() As Byte
Declare Sub Acknowledge(byval B As Byte)                    'b = 0 wenn, kein ACK
Declare Sub Warteaufstart


Dim Sda1 As Byte
Dim Scl1 As Byte
Dim St1 As Byte
Dim I As Byte
Dim Wert As Byte
Dim Wert1 As Byte
Dim Bitwert1 As Byte
Dim Anzeige As String * 3
Dim I2cadr As Byte
Dim Aktiv As Byte

'****************** Initialisierung ***********************

Ddrb = &B01011111                                           'Port B als Ausgangsport, auer B.5 und B.7
Ddrd = &B01110000                                           'D4, D5, D6 als Ausgang; Rest als Eingang
Portd = &B10001111                                          'Eingnge auf high legen

Config Int1 = Rising                                        'INT1 = PortB.3 an SDA = PortB.5
Enable Int1
Enable Interrupts
On Int1 Onstopp


I2cadr = &B00000100                                         'adresse = 4
Aktiv = 0

Config Lcd = 16 * 2                                         'LCD konfigurieren
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.6
Cursor Off
Cls

'**********************************************************
'******************** Hauptprogramm ***********************

Lcd "** Attiny als **"
Lowerline
Lcd "** I2C-Slave  **"
Wait 2
Cls
Lcd "Schlafe..."

Do
 If Aktiv = 0 Then
   Warteaufstart
 End If
 Wert = Empfangebyte()
 If Wert = I2cadr Then
   Call Acknowledge(1)
   Lcd " ACK"
   Aktiv = 1
   Portd.6 = 1
 Else
   Call Acknowledge(0)
   Lcd " NACK"
   Aktiv = 0
   Portd.6 = 0                                              '
 End If
 Wait 2
 While Aktiv > 0
   Cls
   Upperline
   Lcd "bits: "                                             '
   If Aktiv = 1 Then Wert = Empfangebyte()
   If Aktiv = 1 Then Call Acknowledge(1)
   If Aktiv = 1 Then Anzeige = Str(wert)
   If Aktiv = 1 Then Lowerline
   If Aktiv = 1 Then Lcd "Wert: "
   If Aktiv = 1 Then Lcd Anzeige
   If Aktiv = 1 Then Wait 2
 Wend
' Wait 2
 Cls
 Lcd "schlafe wieder..."
Loop

End


'**********************************************************
'******************* Unterprogramme ***********************

Sub Warteaufstart
'Warten bis zuerst SDA und dann SCL auf 0
 Do
   Do : Loop Until Pinb.5 = 1
   Do : Loop Until Pinb.5 = 0
 Loop Until Pinb.7 = 1
 Do : Loop Until Pinb.7 = 0
 Cls
 Lcd "Startsignal ->"
 Lowerline
 Aktiv = 1
 Portd.6 = 1
End Sub

Function Empfangebyte() As Byte
'Jetzt Bit 7 bis Bit 0 lesen
 For I = 0 To 7
  Do : Loop Until Pinb.7 = 1                                'Warten bis SCL auf 1
  Bitwert1 = Pinb.5
  Anzeige = Str(bitwert1)
  Lcd Anzeige
  Wert1 = 2 * Wert1
  Wert1 = Wert1 + Bitwert1
  If Aktiv = 1 Then
   Do : Loop Until Pinb.7 = 0                               'Warten bis SCL wieder auf 0
  Else
   I = 8
   Wert1 = 255                                              'Wert bei Abbruch
  End If
 Next I
 Empfangebyte = Wert1
End Function

Sub Acknowledge(byval B As Byte)
 Ddrb.5 = 1                                                 'PortB.5 als Ausgang konfigurieren
 If B > 0 Then
   Portb.5 = 0
 Else
   Portb.5 = 1
 End If
 Do : Loop Until Pinb.7 = 1                                 'SCL abwarten
 Do : Loop Until Pinb.7 = 0
 Ddrb.5 = 0                                                 'PortB.5 als Eingang konfigurieren
End Sub


'**********************************************************
'******************Interruptroutinen***********************

Onstopp:                                                    'I2C-Stopp-Condition
  If Aktiv = 1 Then
    If Pinb.7 = 1 Then                                      'Wenn SDA von L auf H gegangen ist und SCL dabei schon auf H ist, dann Stopp
      Aktiv = 0
      Portd.6 = 0
    End If
  End If
Return


'**********************************************************